<?php

header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: GET, PUT, PATCH, DELETE");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

include_once '../../config/database.php';
include_once('../../config/config.php');

$database = new Database();
$db = $database->getConnection();   

if ($_SERVER["REQUEST_METHOD"] == "GET") {
    
    $sql = "SELECT ID, name AS Name, Code, DepartmentID FROM category";
            
    $stmt = $db->prepare($sql);
    $stmt->execute();
    $categories = $stmt->fetchAll(PDO::FETCH_ASSOC);

    echo json_encode($categories);

} elseif ($_SERVER["REQUEST_METHOD"] == "PUT" || $_SERVER["REQUEST_METHOD"] == "PATCH") {

    // Update category
    parse_str(file_get_contents("php://input"), $data);
    $id = $data['id'];
    $name = $data['name'];
    $code = $data['code'];
    $department_id = $data['department_id'];

    $sql = "UPDATE category SET name = :name, code = :code, department_id = :department_id WHERE id = :id";
    $stmt = $db->prepare($sql);
    $stmt->bindParam(":name", $name);
    $stmt->bindParam(":code", $code);
    $stmt->bindParam(":department_id", $department_id);
    $stmt->bindParam(":id", $id);
    $stmt->execute();

    // Return success message
    echo json_encode(array("message" => "Category updated successfully."));

} elseif ($_SERVER["REQUEST_METHOD"] == "DELETE") {

   // Get the category ID from the URL parameter
    $id = $_GET['id'];

    $sql = "DELETE FROM department WHERE id = :id";
    $stmt = $db->prepare($sql);
    $stmt->bindParam(":id", $id);
    $stmt->execute();

    // Return success message
    echo json_encode(array("message" => "department deleted successfully."));
}

?>
