<?php
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: *");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

include_once '../../config/database.php';

$database = new Database();
$db = $database->getConnection();

// Handle POST request
if ($_SERVER["REQUEST_METHOD"] == "POST") {
    // Get the promotion data from the POST request
    $json = file_get_contents('php://input');
    $data = json_decode($json, true);
    
    $name = $data["name"];
    $start_date = $data["start_date"];
    $end_date = $data["end_date"];
    $branchid = $data["branchid"];
    $published = $data["published"];
    $promo_message = $data["promo_message"];
    
   

    // Insert the promotion into the promotions table
    $sql = "INSERT INTO promotions (Name, start_time, end_time, branchid,published)
            VALUES (:name, :start_date, :end_date, :branchid, :published)";
    $stmt = $db->prepare($sql);
    $stmt->bindParam(':name', $name);
    $stmt->bindParam(':start_date', $start_date);
    $stmt->bindParam(':end_date', $end_date);
    $stmt->bindParam(':branchid', $branchid);
    $stmt->bindParam(':published', $published);
    $stmt->execute();

    // Get the promotion ID
    $promotion_id = $db->lastInsertId();

    // Insert the promotion notification into the promonotifications table
    $sql = "INSERT INTO promonotifications (promotionID, branchid, message)
            VALUES (:promotion_id, :branchid, :promo_message)";
    $stmt = $db->prepare($sql);
    $stmt->bindParam(':promotion_id', $promotion_id);
    $stmt->bindParam(':branchid', $branchid);
    $stmt->bindParam(':promo_message', $promo_message);
    

    

  if ($stmt->execute()) {
    // Success
    http_response_code(200);
    echo json_encode(array("message" => "Promotion created successfully."));
} else {
    // Error
    http_response_code(500);
    echo json_encode(array("message" => "Unable to create promotion."));
}
}
?>
