<?php
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// Connect to the database
include '../config/database2.php';

   // Validate the API key
$expected_api_key = "8L14irhDOhBUffrmiv2kqUSoSpeIK9D7JYDmsPVS9-M";

$received_api_key = isset($_SERVER['HTTP_AUTH']) ? trim($_SERVER['HTTP_AUTH']) : '';


if ($received_api_key !== $expected_api_key) {
    $response = [
        'success' => false,
        'message' => "Invalid API Key."
    ];
    echo json_encode($response);
    exit; // Terminate the script if the API key is invalid
}

// Check connection
if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
}

// Retrieve historical locations
$result = $conn->query("SELECT * FROM locations");
$historicalLocations = array();
while ($row = $result->fetch_assoc()) {
    $historicalLocations[] = $row;
}

// Retrieve shop locations
$result = $conn->query("SELECT * FROM shop_locations");
$shopLocations = array();
while ($row = $result->fetch_assoc()) {
    $shopLocations[] = $row;
}

// Combine historical and shop locations
$data = array(
    'historicalLocations' => $historicalLocations,
    'shopLocations' => $shopLocations
);

// Return the location data as JSON
header('Content-Type: application/json');
echo json_encode($data);

$conn->close();
?>
