<?php
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// Validate the API key
$expected_api_key = "8L14irhDOhBUffrmiv2kqUSoSpeIK9D7JYDmsPVS9-M";

$received_api_key = isset($_SERVER['HTTP_AUTH']) ? trim($_SERVER['HTTP_AUTH']) : '';


if ($received_api_key !== $expected_api_key) {
    $response = [
        'success' => false,
        'message' => "Invalid API Key."
    ];
    echo json_encode($response);
    exit; // Terminate the script if the API key is invalid
}

$json = file_get_contents('php://input');
$data = json_decode($json, true);
$number = $data['number'];
$password = $data['password'];

// Connect to the database
include '../config/database2.php';

// Check connection
if ($conn->connect_error) {
    $response = [
        'success' => false,
        'message' => 'Database connection error.'
    ];
    echo json_encode($response);
    exit; // Terminate the script if there's a database connection error
}

// Hash the input password
$hashedPassword = md5($password);

// Prepare and execute the SQL statement
$stmt = $conn->prepare("SELECT *
  FROM customer 
  WHERE cell = ? AND password = ?");
$stmt->bind_param("ss", $number, $hashedPassword);
$stmt->execute();
$result = $stmt->get_result();

// Check if a user was found
if ($result->num_rows > 0) {
    $user = $result->fetch_assoc();

    // Return the user data
    $response = [
        'success' => true,
        'data' => [
            'ID' => $user['ID'],
            'Number' => $user['cell'],
            'branchid' => $user['branchid']
        ]
    ];

    echo json_encode($response);
} else {
    // Return an error message if no user was found
    $response = [
        'success' => false,
        'message' => 'Login failed. Incorrect number or password.'
    ];

    echo json_encode($response);
}

$conn->close();
?>
