<?php


  header("Access-Control-Allow-Origin: *");
  header("Content-Type: application/json; charset=UTF-8");
  header("Access-Control-Allow-Methods: POST");
  header("Access-Control-Max-Age: 3600");
  header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");
  
    // Validate the API key
$expected_api_key = "8L14irhDOhBUffrmiv2kqUSoSpeIK9D7JYDmsPVS9-M";

$received_api_key = isset($_SERVER['HTTP_AUTH']) ? trim($_SERVER['HTTP_AUTH']) : '';


if ($received_api_key !== $expected_api_key) {
    $response = [
        'success' => false,
        'message' => "Invalid API Key."
    ];
    echo json_encode($response);
    exit; // Terminate the script if the API key is invalid
}
    
  $json = file_get_contents('php://input');
  $data = json_decode($json, true);

  $phoneNumber = $data['number'];
  $businessShortCode = $data['code'];
  $amount = $data['amount'];
  $AccountReference = $data['refs'];
  

// / Safaricom credentials
$consumerKey = '3JYXecPBEsAhW3FIrQXuoDQTYrVxcDEc';
$consumerSecret = 'zCgbiBQFc5mIFTbW';
$passkey = 'bfb279f9aa9bdbcf158e97dd71a467cd2e0c893059b10f78e6b72ada1ed2c919';
$callbackURL = 'https://smartmall.co.ke/kassmattv2/rms_server/api/paymentcallback.php';

// Set the URLs
$authUrl = 'https://sandbox.safaricom.co.ke/oauth/v1/generate?grant_type=client_credentials';
$sktPushUrl = 'https://sandbox.safaricom.co.ke/mpesa/stkpush/v1/processrequest';

// Generate the access token
function generateAccessToken($consumerKey, $consumerSecret, $authUrl)
{
    $credentials = base64_encode($consumerKey . ':' . $consumerSecret);
    $headers = ['Authorization: Basic ' . $credentials];

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $authUrl);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $response = curl_exec($ch);
    curl_close($ch);

    return json_decode($response)->access_token;
}

// Sanitize and validate the phone number
function sanitizePhoneNumber($phoneNumber)
{
    $sanitizedNumber = preg_replace('/[^0-9]/', '', $phoneNumber);

    if (preg_match('/^254\d{9}$/', $sanitizedNumber)) {
        return $sanitizedNumber;
    }

    if (strlen($sanitizedNumber) === 10 && substr($sanitizedNumber, 0, 1) === '0') {
        $sanitizedNumber = '254' . substr($sanitizedNumber, 1);
    }

    if (!preg_match('/^254\d{9}$/', $sanitizedNumber)) {
        return null;
    }

    return $sanitizedNumber;
}

// Make the SKT Push request
function makeSktPushRequest($accessToken, $sktPushUrl, $businessShortCode, $passkey, $phoneNumber, $callbackURL,$amount,$AccountReference)
{
    $headers = [
        'Content-Type: application/json',
        'Authorization: Bearer ' . $accessToken,
    ];

    $payload = [
        'BusinessShortCode' => $businessShortCode,
        'Password' => base64_encode($businessShortCode . $passkey . date('YmdHis')),
        'Timestamp' => date('YmdHis'),
        'TransactionType' => 'CustomerPayBillOnline',
        'Amount' => $amount, // Amount to charge
        'PartyA' => $phoneNumber, // Customer phone number
        'PartyB' => $businessShortCode,
        'PhoneNumber' => $phoneNumber, // Customer phone number
        'CallBackURL' => $callbackURL,
        'AccountReference' => $AccountReference,
        'TransactionDesc' => 'Payment of goods',
    ];

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $sktPushUrl);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($payload));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $response = curl_exec($ch);
    curl_close($ch);

    return $response;
}

// Generate the access token
$accessToken = generateAccessToken($consumerKey, $consumerSecret, $authUrl);

// Sanitize and validate the phone number
$sanitizedPhoneNumber = sanitizePhoneNumber($phoneNumber);


    // Make the SKT Push request
    $response = makeSktPushRequest($accessToken, $sktPushUrl, $businessShortCode, $passkey, $sanitizedPhoneNumber, $callbackURL,$amount,$AccountReference);

    // Output the response
    echo $response;


?>
