<?php
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: GET");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// Connect to the database
include '../../config/database2.php';
 
// Check connection
if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
}

// Get user ID from query parameter
$userid = $_GET['userid'];
$branchid = $_GET['branchid'];

// Fetch data from Orders table and join with Customer table
$sql = "SELECT o.OrderID, o.CustomerID, c.nickname, c.cell, o.Date, o.DeliveredTime AS PackedTime, o.DeliveryRegion, o.PaymentOption, o.Total
FROM Orders o
JOIN customer c ON o.CustomerID = c.ID
WHERE o.Confirmed = 1 
AND o.Claimed = 1 
AND o.Packed = 1 
AND o.Picked = 1 
AND o.OnDelivery = 1 
AND o.Delivered = 1
AND o.cancelled = 0 
AND o.StoreID = ? 
AND o.OrderID IN (
  SELECT OrderID
  FROM order_user
  WHERE user_id = ?
  AND action = 'ondelivery'
)";

$stmt = $conn->prepare($sql);
$stmt->bind_param('ii', $branchid, $userid);
$stmt->execute();
$orders = $stmt->get_result()->fetch_all(MYSQLI_ASSOC);

// Check if any records were found
if (empty($orders)) {
    // Return empty array
    echo json_encode([]);
} else {
    // Return the orders data
    echo json_encode($orders);
}

$conn->close();

?>
