<?php
  header("Access-Control-Allow-Origin: *");
  header("Content-Type: application/json; charset=UTF-8");
  header("Access-Control-Allow-Methods: POST");
  header("Access-Control-Max-Age: 3600");
  header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

  $json = file_get_contents('php://input');
  $data = json_decode($json, true);

  $email = $data['email'];

  // Connect to the database
  include '../../config/database2.php';

  // Check connection
  if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
  }

 
  
  // Prepare and execute the SQL statement to check if the email exists
  $stmt = $conn->prepare("SELECT email, phone FROM users WHERE email = ?");
  $stmt->bind_param("s", $email);
  $stmt->execute();
  $result = $stmt->get_result();

  // Check if the email was found
  if ($result->num_rows > 0) {
      
     $row = $result->fetch_assoc();
    $phone = $row['phone'];
    $email = $row['email'];
    
    // Generate a new OTP
    $otp = rand(100000, 999999);

    // Update the OTP column in the database
    $stmt = $conn->prepare("UPDATE users SET otp = ? WHERE email = ?");
    $stmt->bind_param("ss", $otp, $email);
    $stmt->execute();
    
    

    // Send the OTP to the email of the user
    $to = $email;
    $subject = "One Time Password";
    $message = "Your password reset code is " . $otp . ". Do not share it with anyone.";
    $headers = "From: miabri@gmail.com\r\n";
    $headers .= "Reply-To: miabri@gmail.com\r\n";
    $headers .= "Content-Type: text/html; charset=UTF-8\r\n";

    $mail_success = mail($to, $subject, $message, $headers);
    
    // Send the OTP to the phone number of the user
    $postData = array(
      'acc_no' => '0311',
      'api_key' => 'T3d2p2m4g7R8zEZejUr6h8h5tAv8PAD1',
      'sender_id' => 'KASSMATT_SM',
      'message' => $message,
      'msisdn' => $phone,
      'dlr_url'=> '',
      'linkID'=> ''
    );

    $url="https://isms.infosky.co.ke/sms2/api/v1/send-sms";

    $ch = curl_init();
    curl_setopt_array($ch, array(
      CURLOPT_URL => $url,
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_POST => true,
      CURLOPT_POSTFIELDS => $postData
    ));

    $sms_success = curl_exec($ch);


// Return a success message if the OTP was sent successfully
    if ($mail_success && $sms_success) {
       $response = [
        'success' => true,
        'message' => 'OTP sent to ' .$phone . ' and ' . $email 
      ];
      echo json_encode($response);
    } else {
      $response = [
        'success' => false,
        'message' => 'Unable to send OTP. Please try again later.'
      ];
      echo json_encode($response);

    }
  } else {
    // Return an error message if the email was not found
    $response = [
      'success' => false,
      'message' => $email . 'does not exist. Please try again.'
    ];
    echo json_encode($response);
  }

  $conn->close();
?>
