<?php
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

  // Validate the API key
$expected_api_key = "8L14irhDOhBUffrmiv2kqUSoSpeIK9D7JYDmsPVS9-M";

$received_api_key = isset($_SERVER['HTTP_AUTH']) ? trim($_SERVER['HTTP_AUTH']) : '';


if ($received_api_key !== $expected_api_key) {
    $response = [
        'success' => false,
        'message' => "Invalid API Key."
    ];
    echo json_encode($response);
    exit; // Terminate the script if the API key is invalid
}

// Get the JSON data from the request body
$json = file_get_contents('php://input');
$data = json_decode($json, true);

// Extract the data fields from the JSON
$customerID = $data['customerID'];
$recipientname = $data['recipientname'];
$recipientphone = $data['recipientphone'];
$recipientemail = $data['recipientemail'];
$road = $data['road'];
$building = $data['building'];
$houseNo = $data['houseNo'];
$floor = $data['floor'];
$region = $data['region'];
$moreinfor = $data['moreinfor'];
$regionname = $data['regionname'];
$shippingFee = $data['shippingFee'];
$deliverytype = $data['deliverytype'];
$orderNumber = $data['ordernumber'];

// Connect to the database
include '../config/database2.php';

// Check connection
if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
}

// Insert the new delivery address into the database
$stmt = $conn->prepare("INSERT INTO deliveryAddress (OrderID, customerID, recipientname, recipientphone, recipientemail, road, building, houseNo, floor, region, moreinfor, regionname, shippingFee, deliverytype) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
$stmt->bind_param("iissssssssssss", $orderNumber, $customerID, $recipientname, $recipientphone, $recipientemail, $road, $building, $houseNo, $floor, $region, $moreinfor, $regionname, $shippingFee, $deliverytype);
$stmt->execute();

// Close the database connection
$conn->close();

// Return a success response
$response = [
    'success' => true,
    'message' => 'Address saved successfully.'
];

echo json_encode($response);
?>
