<?php
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: GET");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

  // Validate the API key
$expected_api_key = "8L14irhDOhBUffrmiv2kqUSoSpeIK9D7JYDmsPVS9-M";

$received_api_key = isset($_SERVER['HTTP_AUTH']) ? trim($_SERVER['HTTP_AUTH']) : '';


if ($received_api_key !== $expected_api_key) {
    $response = [
        'success' => false,
        'message' => "Invalid API Key."
    ];
    echo json_encode($response);
    exit; // Terminate the script if the API key is invalid
}

// Connect to the database
include '../config/database2.php';

// Check connection
if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
}

// Get branchid from query parameter
$branchid = $_GET['branchid'];

// Fetch all flashitens where is_published = true and not expired
$sql = "SELECT savetime.id,savetime.Name,savetime.created_at
        FROM savetime
        WHERE savetime.published = 1 AND savetime.end_time >= NOW()  AND savetime.start_time <= NOW() AND savetime.branchid = ?";
$stmt = $conn->prepare($sql);
$stmt->bind_param('i', $branchid);
$stmt->execute();
$result = $stmt->get_result();
$promotions = [];
while ($row = $result->fetch_assoc()) {
    $promotions[] = $row;
}



// Loop through the promotions and fetch the promo items for each promotion
foreach ($promotions as &$promotion) {
    $promoId = $promotion['id'];
    $sql = "SELECT savetimeitems.id AS fid, 
       savetimeitems.ItemID AS item_id,
       savetimeitems.savetimeID AS flashsale_id,
       inventorylocationitems.quantity,
       inventorylocationitems.price,
       inventorylocationitems.cost,
       item.description AS name,
       item.longdescription AS description,
       item.price AS before_price,
       item.is_serial,
       CONCAT('https://admin.kassmatt.com/dist/img/items/', item.ID, '/', productimages.pic1) AS image_url
FROM savetimeitems
INNER JOIN item ON savetimeitems.ItemID = item.ID
INNER JOIN productimages ON savetimeitems.ItemID = productimages.itemID
INNER JOIN inventorylocationitems ON savetimeitems.ItemID = inventorylocationitems.itemID
WHERE inventorylocationitems.quantity > 1
  AND savetimeitems.savetimeID = ?
  AND productimages.pic1 IS NOT NULL
  AND productimages.pic1 != ''
  AND inventorylocationitems.quantity > 1
  AND productimages.pic1 IS NOT NULL
  AND productimages.pic1 != ''
" ;

    $stmt = $conn->prepare($sql);
    $stmt->bind_param('i', $promoId);
    $stmt->execute();
    $result = $stmt->get_result();
    $promoItems = [];
    while ($row = $result->fetch_assoc()) {
        $promoItems[] = $row;
    }
    
    

   

    // Convert the promo item data into the desired structure
    $promoItems = array_map(function($item) {
        return array(
            'id' =>  '3242042' .$item['fid'] . '+' . $item['price'] . '+' . $item['item_id'],
            'itemID' => $item['item_id'],
            'longDescription' => $item['description'],
            'description' => $item['name'],
            'cost' => $item['cost'],
            'price' => $item['price'],
            'quantity' => $item['quantity'],
            'imageUrl' => $item['image_url'],
            "serial" =>  $item['is_serial']
        );
    }, $promoItems);

    $promotion['items'] = $promoItems;
}

// Return the promotions data
http_response_code(200);
echo json_encode($promotions);
$conn->close();

?>

