<?php
  header("Access-Control-Allow-Origin: *");
  header("Content-Type: application/json; charset=UTF-8");
  header("Access-Control-Allow-Methods: POST");
  header("Access-Control-Max-Age: 3600");
  header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

  // Get the JSON data from the request body
  $json = file_get_contents('php://input');
  $data = json_decode($json, true);
  
    // Validate the API key
$expected_api_key = "8L14irhDOhBUffrmiv2kqUSoSpeIK9D7JYDmsPVS9-M";

$received_api_key = isset($_SERVER['HTTP_AUTH']) ? trim($_SERVER['HTTP_AUTH']) : '';


if ($received_api_key !== $expected_api_key) {
    $response = [
        'success' => false,
        'message' => "Invalid API Key."
    ];
    echo json_encode($response);
    exit; // Terminate the script if the API key is invalid
}

  // Extract the data fields
  $id =  $data['id'];
  $userid = $data['userid'];
  $usercell = $data['usercell'];
  $name = $data['name'];
  $email = $data['email'];
  $mobile = $data['mobile'];
  $road = $data['road'];
  $building = $data['building'];
  $houseNo = $data['houseNo'];
  $floor = $data['floor'];
  $region = $data['region'];
  $moreinfor = $data['moreinfor'];
  $default = $data['default1'];

  // Connect to the database
  include '../config/database2.php';

  // Check connection
  if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
  }

  // Update the existing user address in the database
  $stmt = $conn->prepare("UPDATE userAddress SET cell=?, name=?, email=?, mobile=?, road=?, building=?, houseNo=?, floor=?, region=?, moreinfor=?, `default`=? WHERE id=?");
  $stmt->bind_param("ssssssssssii", $usercell, $name, $email, $mobile, $road, $building, $houseNo, $floor, $region, $moreinfor, $default, $id);
  $stmt->execute();

  // Return a success response
  $response = [
    'success' => true,
    'message' => 'Address updated successfully.'
  ];

  echo json_encode($response);

  $conn->close();
?>
