<?php
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: GET");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// Get the branchid parameter from the request URL
$branchid = isset($_GET['branchid']) ? $_GET['branchid'] : null;

// Validate the API key
$expected_api_key = "8L14irhDOhBUffrmiv2kqUSoSpeIK9D7JYDmsPVS9-M";

$received_api_key = isset($_SERVER['HTTP_AUTH']) ? trim($_SERVER['HTTP_AUTH']) : '';

if ($received_api_key !== $expected_api_key) {
    $response = [
        'success' => false,
        'message' => "Invalid API Key."
    ];
    echo json_encode($response);
    exit; // Terminate the script if the API key is invalid
}

// Connect to the database
include '../config/database3.php';

// Check connection
if ($conn->connect_error) {
    $response = [
        'success' => false,
        'message' => "Connection failed: " . $conn->connect_error
    ];
    echo json_encode($response);
    exit; // Terminate the script if there is a connection error
}

// Fetch the default address associated with the user
$stmt = $conn->prepare("SELECT * FROM streetAddresses WHERE branchId = ?");
$stmt->bind_param("i", $branchid);
$stmt->execute();
$result = $stmt->get_result();

// Fetch data as an associative array
$data = [];
while ($row = $result->fetch_assoc()) {
    $data[] = $row;
}

// Return the address as a JSON response
echo json_encode($data);

$stmt->close();
$conn->close();
?>
