<?php
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: DELETE");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// Validate the API key
$expected_api_key = "8L14irhDOhBUffrmiv2kqUSoSpeIK9D7JYDmsPVS9-M";

$received_api_key = isset($_SERVER['HTTP_AUTH']) ? trim($_SERVER['HTTP_AUTH']) : '';

if ($received_api_key !== $expected_api_key) {
    $response = [
        'success' => false,
        'message' => "Invalid API Key."
    ];
    echo json_encode($response);
    exit; // Terminate the script if the API key is invalid
}

// Get the JSON data from the request body
$json = file_get_contents('php://input');
$data = json_decode($json, true);

// Extract the data fields
// Extract the data fields
$id = isset($_GET['id']) ? $_GET['id'] : null; 
$userid = isset($_GET['userid']) ? $_GET['userid'] : null;


// Connect to the database
include '../config/database3.php'; 

// Check connection
if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
}
// Initialize $deleteQuery
$deleteQuery = null;

// Delete either a specific item or clear the entire cart
if ($id !== null && $id !== '0') {
    // Delete a specific item
    $stmt = $conn->prepare("DELETE FROM cart WHERE id = ?");
    $stmt->bind_param("i", $id);
    $stmt->execute();

    // Check if the deletion was successful
    if ($stmt->affected_rows > 0) {
        $response = [
            'success' => true,
            'message' => 'Cart item deleted successfully.'
        ];
    } else {
        $response = [
            'success' => false,
            'message' => 'Failed to delete cart item. Item not found.'
        ];
    }
} else {
    // Clear the entire cart
  
    $deleteQuery = $conn->prepare("DELETE FROM cart where userid = ?");
    $deleteQuery->bind_param("i", $userid);
    $deleteQuery->execute();
    
    
    if ($deleteQuery->affected_rows > 0) {
          $response = [
        'success' => true,
        'message' => 'Cart cleared successfully.'
    ];
    }else{
         $response = [
            'success' => false,
            'message' => 'Failed to delete cart item.'
        ];
    }

  
}

echo json_encode($response);
if ($deleteQuery !== null) {
    $deleteQuery->close();
}
$conn->close();
?>
