<?php
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

   // Validate the API key
$expected_api_key = "8L14irhDOhBUffrmiv2kqUSoSpeIK9D7JYDmsPVS9-M";

$received_api_key = isset($_SERVER['HTTP_AUTH']) ? trim($_SERVER['HTTP_AUTH']) : '';


if ($received_api_key !== $expected_api_key) {
    $response = [
        'success' => false,
        'message' => "Invalid API Key."
    ];
    echo json_encode($response);
    exit; // Terminate the script if the API key is invalid
}

// Read the request payload
$json = file_get_contents('php://input');
$data = json_decode($json, true);

// Extract the input parameters
$orderID = $data['orderID'];
$customerID = $data['customerID'];
$message = $data['message'];
$rating = $data['rating'];

// Connect to the database
include '../config/database3.php';

// Check connection
if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
}

// Prepare and execute the SQL statement to insert feedback
$stmt = $conn->prepare("INSERT INTO feedback (orderID, customerID, message, rating) VALUES (?, ?, ?, ?)");
$stmt->bind_param("iisi", $orderID, $customerID, $message, $rating);




if ($stmt->execute()) {
    // Get the generated ID of the inserted feedback
    $feedbackID = $stmt->insert_id;

    // Prepare and execute the SQL statement to update Orders table
    $stmt = $conn->prepare("UPDATE Orders SET feedbackid = ? WHERE orderID = ?");
    $stmt->bind_param("ii", $feedbackID, $orderID);
    $stmt->execute();

    // Return a success response if the rating was saved and Orders table was updated successfully
    $response = [
        'success' => true,
        'message' => 'Rating saved successfully'
    ];
    echo json_encode($response);
} else {
    // Return an error response if the rating couldn't be saved
    $response = [
        'success' => false,
        'message' => 'Failed to save rating'
    ];
    echo json_encode($response);
}

$conn->close();
?>
