<?php
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: GET");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// Validate the API key
$expected_api_key = "8L14irhDOhBUffrmiv2kqUSoSpeIK9D7JYDmsPVS9-M";

$received_api_key = isset($_SERVER['HTTP_AUTH']) ? trim($_SERVER['HTTP_AUTH']) : '';

if ($received_api_key !== $expected_api_key) {
    $response = [
        'success' => false,
        'message' => "Invalid API Key."
    ];
    echo json_encode($response);
    exit; // Terminate the script if the API key is invalid
}

$userid = $_GET['userid'];
$branchid =  $_GET['branchid'];

// Connect to the database
include '../config/database3.php'; 
include '../config/url.php';

// Check connection
if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
}

// Fetch all cart items from the database
$stmt = $conn->prepare("
SELECT 
    c.id,
    c.itemid,
    c.quantity,
    c.branchid,
    c.userid,
    c.type,
    p.Description AS name,
        CASE 
        WHEN p.SerialNumberCount IS NOT NULL AND p.SerialNumberCount > 0 THEN 1
        ELSE 0
    END AS is_serial,
    CASE 
            WHEN p.Inactive = 0 THEN 'Active'
            WHEN p.Inactive = 1 THEN 'Inactive'
            ELSE 'Unknown'
        END AS status,
    CASE 
        WHEN c.type = 'product' THEN p.Price
        WHEN c.type = 'flashsale' THEN fs.price
        WHEN c.type = 'promotion' THEN pr.price
        WHEN c.type = 'discount' THEN d.price
        ELSE NULL
    END AS price,
    CASE 
        WHEN c.type = 'product' THEN p.quantity
        WHEN c.type = 'flashsale' THEN fs.quantity
        WHEN c.type = 'promotion' THEN pr.quantity
        WHEN c.type = 'discount' THEN d.quantity
        ELSE NULL
    END AS availablequantity,
    CONCAT('$url', c.itemid, '/', pi.pic1) AS imageUrl,
   
      CASE 
        WHEN c.type = 'product' THEN p.Price * c.quantity
        WHEN c.type = 'flashsale' THEN fs.price * c.quantity
        WHEN c.type = 'promotion' THEN pr.price * c.quantity
        WHEN c.type = 'discount' THEN d.price * c.quantity
        ELSE NULL
    END AS totalprice
FROM 
    cart c
    
LEFT JOIN 
    item p ON c.itemid = p.ID
    
LEFT JOIN 
    item fs ON c.itemid = fs.ID
    
LEFT JOIN 
    item pr ON c.itemid = pr.ID
    
LEFT JOIN 
    item d ON c.itemid = d.ID
    
LEFT JOIN 
    productimages pi ON c.itemid = pi.itemID

    
WHERE 
    c.userid = ? 
     AND (
        (c.type = 'product' AND p.quantity > 0)
        OR (c.type = 'flashsale' AND fs.quantity > 0)
        OR (c.type = 'promotion' AND pr.quantity > 0)
        OR (c.type = 'discount' AND d.quantity > 0)
    )
");



$stmt->bind_param("i", $userid);
$stmt->execute();
$result = $stmt->get_result();


// Check if there are any cart items
if ($result->num_rows > 0) {
    $cartItems = [];

    while ($row = $result->fetch_assoc()) {
        $cartItems[] = $row;
    }

} else {
  
  $cartItems = [];
}

http_response_code(200);
echo json_encode($cartItems);
$conn->close();
?>
