<?php
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// Validate the API key
$expected_api_key = "8L14irhDOhBUffrmiv2kqUSoSpeIK9D7JYDmsPVS9-M";

$received_api_key = isset($_SERVER['HTTP_AUTH']) ? trim($_SERVER['HTTP_AUTH']) : '';


if ($received_api_key !== $expected_api_key) {
    $response = [
        'success' => false,
        'message' => "Invalid API Key."
    ];
    echo json_encode($response);
    exit; // Terminate the script if the API key is invalid
}

$json = file_get_contents('php://input');
$data = json_decode($json, true);
$number = $data['number'];
$password = $data['password'];
$branch = $data['branch'];

error_log("branchid".$branch);

  if (empty($number)) {
    $response = [
        'success' => false,
        'message' => 'Mobile is required for login.'
    ];
    echo json_encode($response);
    exit; // Terminate the script if the mobile is not provided
}

// Connect to the database
include '../config/database3.php';

// Check connection
if ($conn->connect_error) {
    $response = [
        'success' => false,
        'message' => 'Database connection error.'
    ];
    echo json_encode($response);
    exit; // Terminate the script if there's a database connection error
}

// Hash the input password
$hashedPassword = md5($password);

// Prepare and execute the SQL statement
$stmt = $conn->prepare("SELECT ID,Mobile,STID,Password FROM members WHERE Mobile = ?");
$stmt->bind_param("s", $number);
$stmt->execute();
$result = $stmt->get_result();

// Check if a user was found
if ($result->num_rows > 0) {
    // User found, fetch user data
    $user = $result->fetch_assoc();

    // Check if the password is NULL
     if (empty($user['Password'])) {
        // Password is NULL, suggest resetting
        $response = [
            'success' => false,
            'message' => 'Please reset your password to login.',
            'data' => [
                    'ID' => '',
                    'Number' => '',
                    'branchid' => ''
                ]
        ];
    } else {
        // Password is not NULL, check if it matches the input
        if (md5($password) === $user['Password']) {
            // Password matches, return success and user data
            $response = [
                'success' => true,
                'message' => "login successful",
                'data' => [
                    'ID' => $user['ID'],
                    'Number' => $user['Mobile'],
                    'branchid' => $user['STID']
                ]
            ];
        } else {
            // Password is not NULL but incorrect
            $response = [
                'success' => false,
                'message' => 'Login failed. Password is incorrect.',
                'data' => [
                    'ID' => '',
                    'Number' => '',
                    'branchid' => ''
                ]
                
            ];
        }
    }
} else {
    // No user found
    $response = [
        'success' => false,
        'message' => 'User not found. Please register to log in.',
        'data' => [
                    'ID' => '',
                    'Number' => '',
                    'branchid' => ''
                ]
    ];
}

// Output the JSON response
echo json_encode($response);

// Close the database connection
$conn->close();
?>