<?php
  header("Access-Control-Allow-Origin: *");
  header("Content-Type: application/json; charset=UTF-8");
  header("Access-Control-Allow-Methods: POST");
  header("Access-Control-Max-Age: 3600");
  header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

  // Get the JSON data from the request body
  $json = file_get_contents('php://input');
  $data = json_decode($json, true);
  
    // Validate the API key
$expected_api_key = "8L14irhDOhBUffrmiv2kqUSoSpeIK9D7JYDmsPVS9-M";

$received_api_key = isset($_SERVER['HTTP_AUTH']) ? trim($_SERVER['HTTP_AUTH']) : '';


if ($received_api_key !== $expected_api_key) {
    $response = [
        'success' => false,
        'message' => "Invalid API Key."
    ];
    echo json_encode($response);
    exit; // Terminate the script if the API key is invalid
}

  // Extract the data fields
  $mobile = $data['mobile'];
  $id = $data['id'];
  $idnumber = $data['idnumber'];
  $fullname = $data['fullname'];
  $gender = $data['gender'];
  $town = $data['town'];
  $physicalAddress = $data['physicalAddress'];
  $postalAddress = $data['postalAddress'];
  $email = $data['email'];
  $dateOfBirth = $data['dateOfBirth'];

  // Connect to the database
  include '../config/database3.php';

  // Check connection
  if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
  }
  

  // Check if the mobile number already exists in the database
  $stmt = $conn->prepare("SELECT Mobile FROM members WHERE id = ?");
  $stmt->bind_param("s", $id);
  $stmt->execute();
  $result = $stmt->get_result();

  // If no user exists with the given mobile number, return an error response
  if ($result->num_rows == 0) {
    $response = [
      'success' => false,
      'message' => 'Update failed. User does not exist.'
    ];

    echo json_encode($response);
  } else {
    // Otherwise, update the user's information in the database
   $stmt = $conn->prepare("UPDATE members SET Fullname = ?,Idnumber =?, Gender = ?, Town = ?, physicaladdress = ?, Postaladdress = ?, EmailAdd = ?, DateofBirth = ? where id = ?");
    $stmt->bind_param("sssssssss", $fullname,$idnumber, $gender, $town, $physicalAddress, $postalAddress, $email, $dateOfBirth,$id);
    $stmt->execute();

    // Return a success response
    $response = [
      'success' => true,
      'message' => 'Data Updated successfully'
    ];

    echo json_encode($response);
  }

  $conn->close();
?>
