<?php
    class Orders{

        // Connection
        private $conn;

        // Table
        private $db_table = "Orders";

        // Columns
        public $OrderID;
        public $CustomerID;
        public $tdatetime;
        public $Total;
        public $TotalWeight;
        public $PaymentOption;
        public $DeliveryOption;
        public $DeliveryRegion;
        public $StoreID;
        public $ItemID;
        public $Cost;
        public $Price;
        public $FullPrice;
        public $Quantity;
        public $SalesTax;
        public $type;
        public $ShippingFees;
        public $Amount;
        public $serialNumber;
        public $Payment;
        
      
        
        
   
   
      
        // Db connection
        public function __construct($db){
            $this->conn = $db;
        }



        //post orders
        function postOders(){

            $sqlQuery = "INSERT INTO
            Orders
        SET
        OrderID = :OrderID,
        CustomerID = :CustomerID, 
        Total = :Total, 
        Payment = :Payment,
        TotalWeight = :TotalWeight, 
        PaymentOption = :PaymentOption,
        DeliveryOption =:DeliveryOption,
        DeliveryRegion =:DeliveryRegion,
        ShippingFees =:ShippingFees,
        Amount =:Amount,
        StoreID =:StoreID ";

        
       $stmt = $this->conn->prepare($sqlQuery);

        
         
         //clean data
$this->OrderID = isset($this->OrderID) ? htmlspecialchars(strip_tags($this->OrderID)) : null;
$this->CustomerID = isset($this->CustomerID) ? htmlspecialchars(strip_tags($this->CustomerID)) : null;
$this->Total = isset($this->Total) ? htmlspecialchars(strip_tags($this->Total)) : null;
$this->Payment = isset($this->Payment) ? htmlspecialchars(strip_tags($this->Payment)) : null;
$this->TotalWeight = isset($this->TotalWeight) ? htmlspecialchars(strip_tags($this->TotalWeight)) : null;
$this->PaymentOption = isset($this->PaymentOption) ? htmlspecialchars(strip_tags($this->PaymentOption)) : null;
$this->DeliveryOption = isset($this->DeliveryOption) ? htmlspecialchars(strip_tags($this->DeliveryOption)) : null;
$this->DeliveryRegion = isset($this->DeliveryRegion) ? htmlspecialchars(strip_tags($this->DeliveryRegion)) : null;
$this->StoreID = isset($this->StoreID) ? htmlspecialchars(strip_tags($this->StoreID)) : null;
$this->Amount = isset($this->Amount) ? htmlspecialchars(strip_tags($this->Amount)) : null;
$this->ShippingFees = isset($this->ShippingFees) ? htmlspecialchars(strip_tags($this->ShippingFees)) : null;


 
            
         //bind data
            $stmt->bindParam(":OrderID", $this->OrderID);
            $stmt->bindParam(":CustomerID", $this->CustomerID);
            $stmt->bindParam(":Total", $this->Total);
            $stmt->bindParam(":TotalWeight", $this->TotalWeight);
            $stmt->bindParam(":PaymentOption", $this->PaymentOption);
            $stmt->bindParam(":DeliveryOption", $this->DeliveryOption);
            $stmt->bindParam(":DeliveryRegion", $this->DeliveryRegion);
            $stmt->bindParam(":StoreID", $this->StoreID);
            $stmt->bindParam(":ShippingFees", $this->ShippingFees);
            $stmt->bindParam(":Amount", $this->Amount);
            $stmt->bindParam(":Payment", $this->Payment);
            
          
        
          if($stmt->execute()){
             $this->updateCustomerPoints(); 
                return true;
                
            }

            //print error if something goes wrong
            printf("Errror %s.\n",$stmt->error);
         
            return false;
        }


          //post orders entry
        // post orders entry
function postOdersEntry()
{
    $sqlQuery = "INSERT INTO OrdersEntry
                SET OrderID = :OrderID, 
                    ItemID = :ItemID, 
                    Cost = :Cost, 
                    Price = :Price, 
                    FullPrice = :FullPrice,
                    Quantity = :Quantity,
                    SalesTax = :SalesTax,
                    type = :type,
                    serialNumber = :serialNumber
                    ";

    $stmt = $this->conn->prepare($sqlQuery);

    // Clean data
$this->OrderID = isset($this->OrderID) ? htmlspecialchars(strip_tags($this->OrderID)) : null;
$this->ItemID = isset($this->ItemID) ? htmlspecialchars(strip_tags($this->ItemID)) : null;
$this->Cost = isset($this->Cost) ? htmlspecialchars(strip_tags($this->Cost)) : null;
$this->Price = isset($this->Price) ? htmlspecialchars(strip_tags($this->Price)) : null;
$this->FullPrice = isset($this->FullPrice) ? htmlspecialchars(strip_tags($this->FullPrice)) : null;
$this->Quantity = isset($this->Quantity) ? htmlspecialchars(strip_tags($this->Quantity)) : null;
$this->SalesTax = isset($this->SalesTax) ? htmlspecialchars(strip_tags($this->SalesTax)) : null;
$this->type = isset($this->type) ? htmlspecialchars(strip_tags($this->type)) : null;
$this->serialNumber = isset($this->serialNumber) ? htmlspecialchars(strip_tags($this->serialNumber)) : null;
$this->branchid = isset($this->branchid) ? htmlspecialchars(strip_tags($this->branchid)) : null;





    
    
    

    // Bind data
    $stmt->bindParam(":OrderID", $this->OrderID);
    $stmt->bindParam(":ItemID", $this->ItemID);
    $stmt->bindParam(":Cost", $this->Cost);
    $stmt->bindParam(":Price", $this->Price);
    $stmt->bindParam(":FullPrice", $this->FullPrice);
    $stmt->bindParam(":Quantity", $this->Quantity);
    $stmt->bindParam(":SalesTax", $this->SalesTax);
    $stmt->bindParam(":type", $this->type);
    $stmt->bindParam(":serialNumber", $this->serialNumber);
    
    
    // Execute the INSERT statement
if ($stmt->execute()) {
 
    
  
   
    // Begin a transaction
    $this->conn->beginTransaction();

    try {
        // Decrement the quantity based on the type
        switch ($this->type) {
            case 'product':
                $updateQuery = "UPDATE item 
                                SET quantity =  quantity - :Quantity 
                                WHERE ID = :ItemID "; 
                break;

            case 'discount':
                $updateQuery = "UPDATE discounts 
                                SET quantity = quantity - :Quantity 
                                WHERE ItemID = :ItemID";
                break;

            case 'flashsale':
                $updateQuery = "UPDATE flashsale 
                                SET quantity = quantity - :Quantity 
                                WHERE ItemID = :ItemID";
                break;

            // Add more cases for other types if needed

            default:
                throw new Exception("Unsupported type: " . $this->type);
        }
        
      

        $updateStmt = $this->conn->prepare($updateQuery);

        // Bind the ItemID and Quantity
        $updateStmt->bindParam(":ItemID", $this->ItemID);
        $updateStmt->bindParam(":Quantity", $this->Quantity);
       

    
        // Execute the UPDATE statement
        if ($updateStmt->execute()) {
            // Commit the transaction if both queries are successful
            $this->conn->commit();
            return true;
        } else {
          //  Rollback the transaction if the UPDATE fails
            $this->conn->rollBack();
            printf("Error updating quantity: %s.\n", $updateStmt->error);
            return false;
            
       
            
        }
    } catch (Exception $e) {
        // Handle exceptions and rollback the transaction
        $this->conn->rollBack();
        printf("Error: %s.\n", $e->getMessage());
        return false;
    }
} else {
    // Print error if something goes wrong with the INSERT statement
    printf("Error: %s.\n", $stmt->error);
    return false;
}

}




public function updateCustomerPoints()
{
    // Calculate the points 
   
 

    // Update the points in the members table
$updatePointsQuery = "UPDATE members 
                     SET Points = Points + :pointsToAdd,
                         PointsBalance = PointsBalance + :pointsToAdd
                     WHERE ID = :CustomerID";

$stmt = $this->conn->prepare($updatePointsQuery);

// Bind the points and CustomerID
$stmt->bindParam(":pointsToAdd", $pointsToAdd);
$stmt->bindParam(":CustomerID", $this->CustomerID);


    // Execute the UPDATE statement
    if ($stmt->execute()) {
        return true;
    } else {
        
      
        printf("Error updating points: %s.\n", $stmt->error);
        return false;
    }
}


    }
?>

